/* Copyright (c) 2002 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor menu.c */

#include <unistd.h>
#include <stdlib.h>
#include <errno.h>
#include "strukturyw.h"
#include "struktury.h"
#include "libw.h"
#include "lib.h"
#include "priorita.h"

#ifdef PSANIPROFI
extern type_nastaveni nastaveni;

static int getch3_halfdelay = 0;

void getch3setHalfDelay(int tenths)
{
    getch3_halfdelay = tenths;
    if (tenths)
        halfdelay2(getch3_halfdelay);
    else
        cbreak2();
}
#endif

int getch3(void)
{
    static int nap = 0;         /* napoveda je spustena */
    static int kla = 0;         /* zobrazeni klavesnice je spusteno */
#ifdef PSANIPROFI
    static int qwz = 0;         /* nastaveni qwertz90 je spusteno */
#endif
    int ch;
    int intrpt = 0;
    do {
        if ((ch = getch2()) == ERR) {
#ifdef PSANIPROFI
            if (!getch3_halfdelay)
#endif
                print_hl(1, "Chyba ten klvesnice!");
            intrpt++;
            if (errno != EINTR || intrpt > 10) {        /* v gdb pri zmene velikosti xtermu dochazi k EINTR */
#ifdef PSANIPROFI
                if (getch3_halfdelay)
                    return '\0';
#endif
                if (global_get(g_warning) == g_w_ano)
                    fprintf(stderr, "getch3() vratil ERR\n");
                konec(strerror(errno));
            }
            /* TODO:sleep pul vteriny */
            continue;
        }

        if (global_get(g_qwertz) == g_q_z)
            switch (ch) {
            case 'y':
                ch = 'z';
                break;
            case 'Y':
                ch = 'Z';
                break;
            case 'z':
                ch = 'y';
                break;
            case 'Z':
                ch = 'Y';
                break;
            }

        if ((global_get(g_us) == g_us_us) && (ch != '\0')) {
            ch = ustocz(ch);
            if (ch == '\0')     /* hacek nebo carka */
                continue;
        }
#ifdef PSANIPROFI
        if (get_priorita_show_stdscr()) {
            /* pokud zobrazuji pozadi a nezmackl jsem CTRL+o, pak vsechny klavesy ignoruji */
            if ((ch != 'o' - 'a' + 1) && ch != KEY_F(10)) {
                print_hl(1,
                         "Stisknte CTRL+o pro optovn zobrazen pracovn plochy programu.");
                continue;
            }
        }
#endif

        switch (ch) {
        case KEY_F(1):
            if (!nap) {
                nap = 1;
                napoveda();
                nap = 0;
            }
            break;
        case KEY_F(2):
            if (!kla) {
                kla = 1;
                klavesnice();
                kla = 0;
            }
            break;
#ifdef PSANIPROFI
        case KEY_F(3):
            if (!qwz) {
                qwz = 1;
                qwertz(&nastaveni);
                qwz = 0;
            }
            break;
#endif
        case KEY_F(4):
            redrawwin2(stdscr);
            print_hl(1, "Obrazovka vyitna");
            tiskni_dle_priority();
            break;
        case KEY_F(12):
            return KEY_BACKSPACE;
#ifdef _ZOBRAZRADKUTESTU
        case KEY_F(5):
            global_set(g_zobraz_radek, !global_get(g_zobraz_radek));
            print_hl(1,
                     global_get(g_zobraz_radek) ?
                     "Zobrazovn dk pi psan testu bylo zapnuto." :
                     "Zobrazovn dk pi psan testu bylo vypnuto.");
            if (global_get(g_run) == g_run_t) {
                return KEY_F(5);
            }
            break;
#endif
#ifndef PSANIPROFI
        case KEY_F(3):
#endif
#ifndef _ZOBRAZRADKUTESTU
        case KEY_F(5):
#endif
        case KEY_F(6):
        case KEY_F(7):
        case KEY_F(9):
#ifndef PSANIPROFI
        case KEY_F(8):
        case KEY_F(11):
#endif
            break;              /* ignorujeme tyto klavesy */
        case KEY_F(10):
            if (global_get(g_run) == g_run_t)
                print_hl(1,
                         "Psan testu nelze ukonit! Pili by jste tak o 1 pokus!");
            else
                konec("Goodbye!");
            break;
#ifdef PSANIPROFI
        case KEY_F(8):
            tisk_obrazovky();
            break;
        case KEY_F(11):
            lock();
            break;
        case 'o' - 'a' + 1:    /* CTRL+o */
            if (global_get(g_run) == g_run_t)
                print_hl(1, "CTRL+O nen bhem psan testu dostupn.");
            priorita_show_stdscr();
            tiskni_dle_priority();
            break;
#endif
        default:
            return ch;
        }
    }
    while (1);

    return '?';
}
