/* Copyright (c) 2002 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor vl_metronom.c */

#include <unistd.h>
#include <stdlib.h>
#include <pthread.h>
#include <time.h>

#include "strukturyw.h"
#include "struktury.h"
#include "libw.h"
#include "lib.h"

void *vl_metronom(void *arg)
{
    type_nastaveni *nastaveni = (type_nastaveni *) arg;
    struct timespec show = { 0, 0 };
    struct timespec sleep = { 0, 0 };
    unsigned long interval;
    int i;

    i = pthread_setcanceltype(PTHREAD_CANCEL_ASYNCHRONOUS, NULL);
    if (i && (global_get(g_warning) == g_w_ano)) {
        print_hl(1,
                 "vl_metronom: Selhalo nastaveni priznaku ukonceni funkce varovani");
        return NULL;
    }
    do {
        pthread_testcancel();
        show.tv_nsec = 500000000UL;
        if ((nastaveni->metronom > 0) && (global_get(g_run) != g_run_null)) {
            wattron2(sub_nadpis, A_REVERSE);
            obnov_nadpis();
            tiskni_dle_priority();
            wattroff2(sub_nadpis, A_REVERSE);
            /* vypocet cekan */
            sleep.tv_nsec =
                (60000000000UL / (unsigned long) nastaveni->metronom);
            if (show.tv_nsec >= sleep.tv_nsec) {
                show.tv_nsec = sleep.tv_nsec / 2;
            }
            sleep.tv_nsec -= show.tv_nsec;
            sleep.tv_sec = (time_t) (sleep.tv_nsec / 1000000000UL);
            sleep.tv_nsec %= 1000UL * 1000UL * 1000UL;
            /* cekani */
            nanosleep(&show, NULL);
            obnov_nadpis();
            tiskni_dle_priority();
            nanosleep(&sleep, NULL);
        } else {
            /* aby nam to nebrzdilo program TODO: resit pres semafory */
            nanosleep((const struct timespec *) &show, NULL);
        }
    }
    while (1);
    pthread_exit(0);
}
